#!/system/bin/sh
# Relljawa
# give credit if you use any part!!
# telegram dev @reljawa
# sync 
sync

# limit background system
echo 0-2 > /dev/cpuset/system-background/effective_cpus
echo 0-2 > /dev/cpuset/system-background/cpus

# cpu_ctrl
# Menentukan direktori yang akan dicek
directory=/sys/bus/cpu/devices/

# Memeriksa apakah direktori tersebut ada
if [ -d "$directory" ]; then
    # Melakukan iterasi pada semua file di dalam direktori
    for file in "$directory"/*; do
        if [ -d "$file" ]; then
            # Mengambil nomor CPU dari jalur file
            cpu=$(basename "$file")
            
            # Mengaktifkan core_ctl untuk CPU yang terdeteksi
            echo "40" > "$file/core_ctl/busy_down_thres"
            echo "60" > "$file/core_ctl/busy_up_thres"
            echo "500" > "$file/core_ctl/offline_delay_ms"
            echo "5" > "$file/core_ctl/max_cpus"
            echo "1" > "$file/core_ctl/enable"
            echo "1" > "$file/cpufreq/schedutil/rtg_boost_freq"
            echo "0" > "$file/cpufreq/schedutil/up_rate_limit_us"
            
        fi
    done
else
    echo "Direktori $directory tidak ditemukan."
fi

echo 0x40000004 > /proc/thread-self/personality
echo 1 /proc/self/sched_init_task_load

# thermal zone
echo disabled > /sys/class/thermal/thermal_zone0/mode
echo disabled > /sys/class/thermal/thermal_zone1/mode
echo disabled > /sys/class/thermal/thermal_zone2/mode
echo disabled > /sys/class/thermal/thermal_zone3/mode
echo disabled > /sys/class/thermal/thermal_zone4/mode
echo disabled > /sys/class/thermal/thermal_zone5/mode
echo disabled > /sys/class/thermal/thermal_zone6/mode
echo disabled > /sys/class/thermal/thermal_zone7/mode
echo disabled > /sys/class/thermal/thermal_zone8/mode
echo disabled > /sys/class/thermal/thermal_zone9/mode
echo disabled > /sys/class/thermal/thermal_zone10/mode
echo disabled > /sys/class/thermal/thermal_zone11/mode
echo disabled > /sys/class/thermal/thermal_zone12/mode
echo disabled > /sys/class/thermal/thermal_zone13/mode
echo disabled > /sys/class/thermal/thermal_zone14/mode
echo disabled > /sys/class/thermal/thermal_zone15/mode
echo disabled > /sys/class/thermal/thermal_zone16/mode
echo disabled > /sys/class/thermal/thermal_zone17/mode
echo disabled > /sys/class/thermal/thermal_zone18/mode
echo disabled > /sys/class/thermal/thermal_zone19/mode
echo disabled > /sys/class/thermal/thermal_zone20/mode
echo disabled > /sys/class/thermal/thermal_zone21/mode
echo disabled > /sys/class/thermal/thermal_zone22/mode
echo disabled > /sys/class/thermal/thermal_zone23/mode
echo disabled > /sys/class/thermal/thermal_zone24/mode
echo disabled > /sys/class/thermal/thermal_zone25/mode
echo disabled > /sys/class/thermal/thermal_zone26/mode
echo disabled > /sys/class/thermal/thermal_zone27/mode
echo disabled > /sys/class/thermal/thermal_zone28/mode
echo disabled > /sys/class/thermal/thermal_zone29/mode
echo disabled > /sys/class/thermal/thermal_zone30/mode

# optimizing I/O
echo 0 > /sys/block/sda/queue/iosched/slice_idle

echo 1 > /proc/2/sched_boost
echo 1 > /proc/3/sched_boost
echo 1 > /proc/6/sched_boost
echo 1 > /proc/18224/sched_boost

echo 1 > /proc/18224/sched_init_task_load

echo 1 > /dev/stune/schedtune.colocate
echo 1 > /dev/stune/schedtune.schedtune_boost
echo 1 > /dev/stune/rt/schedtune.schedtune_boost
echo 0 > /dev/stune/schedtune.sched_boost_no_override

echo 1 > /dev/cpuset/memory_spread_slab
echo 1 > /dev/cpuset/top-app/sched_relax_domain_level

echo 500 > /proc/sys/kernel/random/write_wakeup_threshold

echo 80 > /sys/bus/cpu/devices/cpu0/cpufreq/schedutil/hispeed_load

echo $(cat /sys/devices/system/cpu/cpu0/cpufreq/cpuinfo_max_freq) > /sys/bus/cpu/devices/cpu0/cpufreq/schedutil/rtg_boost_freq

echo "1 2 3 4" > /sys/bus/cpu/devices/cpu*/cache/index0/shared_cpu_list
echo "1 2 3 4" > /sys/bus/cpu/devices/cpu*/cache/index1/shared_cpu_list
echo "1 2 3 4" > /sys/bus/cpu/devices/cpu*/cache/index2/shared_cpu_list

# threads and cache
echo 0xff > /sys/bus/cpu/devices/cpu*/cache/index0/shared_cpu_map
echo 0xff > /sys/bus/cpu/devices/cpu*/cache/index1/shared_cpu_map
echo 0xff > /sys/bus/cpu/devices/cpu*/cache/index2/shared_cpu_map

echo 300 > /sys/kernel/gpu/gpu_min_clock

echo 0xff > /sys/bus/cpu/devices/cpu0/topology/thread_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu1/topology/thread_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu2/topology/thread_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu3/topology/thread_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu4/topology/thread_sibilings


echo 0xff > /sys/bus/cpu/devices/cpu0/topology/core_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu1/topology/core_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu2/topology/core_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu3/topology/core_sibilings
echo 0xff > /sys/bus/cpu/devices/cpu4/topology/core_sibilings

echo 0-5 > /sys/bus/cpu/devices/cpu0/topology/core_sibilings_list
echo 0-5 > /sys/bus/cpu/devices/cpu1/topology/core_sibilings_list
echo 0-5 > /sys/bus/cpu/devices/cpu2/topology/core_sibilings_list
echo 0-5 > /sys/bus/cpu/devices/cpu3/topology/core_sibilings_list
echo 0-5 > /sys/bus/cpu/devices/cpu4/topology/core_sibilings_list

# disable sched overide for top-app and opt
echo 0 > /dev/stune/top-app/schedtune.sched_boost_no_override
echo 1 > /dev/cpuset/top-app/memory_migrate
echo 1 > /dev/cpuset/top-app/memory_spread_page

# memory tweaker
echo 1 > /dev/memcg/memory.use_hierarchy
echo 1 > /dev/memcg/apps/memory.move_charge_at_immigrate

# better sched and kernel
echo 1 > dev/stune/rt/schedtune.colocate
echo 90 > /dev/stune/top-app/schedtune.boost

# Function To Execute Preload
nohup sh $MODDIR/script/preload.sh &

exit 0